---
title: WebGLRenderingContext.stencilFunc()
slug: Web/API/WebGLRenderingContext/stencilFunc
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.stencilFunc()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> sets the front and back function and reference value for stencil testing.</p>

<p>Stenciling enables and disables drawing on a per-pixel basis. It is typically used in multipass rendering to achieve special effects.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.stencilFunc(<var>func</var>, <var>ref</var>, <var>mask</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>func</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the test function. The default function is <code>gl.ALWAYS</code>. The possible values are:
 <ul>
  <li><code>gl.NEVER</code>:       Never pass.</li>
  <li><code>gl.LESS</code>:         Pass if <code>(ref &amp; mask) &lt;  (stencil &amp; mask)</code>.</li>
  <li><code>gl.EQUAL</code>:       Pass if <code>(ref &amp; mask) =  (stencil &amp; mask)</code>.</li>
  <li><code>gl.LEQUAL</code>:     Pass if <code>(ref &amp; mask) &lt;= (stencil &amp; mask)</code>.</li>
  <li><code>gl.GREATER</code>:   Pass if <code>(ref &amp; mask) &gt;  (stencil &amp; mask)</code>.</li>
  <li><code>gl.NOTEQUAL</code>: Pass if <code>(ref &amp; mask) != (stencil &amp; mask)</code>.</li>
  <li><code>gl.GEQUAL</code>:     Pass if <code>(ref &amp; mask) &gt;= (stencil &amp; mask)</code>.</li>
  <li><code>gl.ALWAYS</code>:     Always pass.</li>
 </ul>
 </dd>
 <dt><code>ref</code></dt>
 <dd>A {{domxref("GLint")}} specifying the reference value for the stencil test. This value is clamped to the range 0 to 2<sup>n</sup> -1 where n is the number of bitplanes in the stencil buffer. The default value is 0.</dd>
 <dt><code>mask</code></dt>
 <dd>A {{domxref("GLuint")}} specifying a bit-wise mask that is used to AND the reference value and the stored stencil value when the test is done. The default value is all 1.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<p>The stencil testing is disabled by default. To enable or disable stencil testing, use the {{domxref("WebGLRenderingContext.enable", "enable()")}} and {{domxref("WebGLRenderingContext.disable", "disable()")}} methods with the argument <code>gl.STENCIL_TEST</code>.</p>

<pre class="brush: js">gl.enable(gl.STENCIL_TEST);
gl.stencilFunc(gl.LESS, 0, 0b1110011);
</pre>

<p>To get the current stencil function, reference value, or other stencil information, query the following constants with {{domxref("WebGLRenderingContext.getParameter", "getParameter()")}}.</p>

<pre class="brush: js">gl.getParameter(gl.STENCIL_FUNC);
gl.getParameter(gl.STENCIL_VALUE_MASK);
gl.getParameter(gl.STENCIL_REF);
gl.getParameter(gl.STENCIL_BACK_FUNC);
gl.getParameter(gl.STENCIL_BACK_VALUE_MASK);
gl.getParameter(gl.STENCIL_BACK_REF);
gl.getParameter(gl.STENCIL_BITS);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.3", "stencilFunc")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glStencilFunc.xml", "glStencilFunc")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.stencilFunc")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.stencilFuncSeparate()")}}</li>
 <li>{{domxref("WebGLRenderingContext.stencilMask()")}}</li>
 <li>{{domxref("WebGLRenderingContext.stencilMaskSeparate()")}}</li>
 <li>{{domxref("WebGLRenderingContext.stencilOp()")}}</li>
 <li>{{domxref("WebGLRenderingContext.stencilOpSeparate()")}}</li>
</ul>
